(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/cdk/coercion'), require('@angular/core'), require('@ng-tangram/animate/fading'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/animations', '@angular/cdk/coercion', '@angular/core', '@ng-tangram/animate/fading', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.callout = {}),global.ng.animations,global.ng.cdk.coercion,global.ng.core,global.nt.animate.fading,global.ng.common));
}(this, (function (exports,animations,coercion,core,fading,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NtCalloutComponent = /** @class */ (function () {
        function NtCalloutComponent() {
            this.title = '';
            this.color = 'primary';
            this.size = 'medium';
            this.class = '';
            this._closed = false;
            this.close = new core.EventEmitter();
            this.fadeOut = false;
        }
        Object.defineProperty(NtCalloutComponent.prototype, "closed", {
            get: /**
             * @return {?}
             */
            function () { return this._closed; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtCalloutComponent.prototype, "closable", {
            get: /**
             * @return {?}
             */
            function () { return this._closable; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._closable = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        NtCalloutComponent.prototype.onAnimationDone = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.toState) {
                this._closed = true;
            }
        };
        /**
         * @return {?}
         */
        NtCalloutComponent.prototype._close = /**
         * @return {?}
         */
        function () {
            if (!this.fadeOut) {
                this.fadeOut = true;
                this.close.emit();
            }
        };
        NtCalloutComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-callout',
                        template: "\n    <h3 *ngIf=\"title\">{{title}}</h3>\n    <ng-content></ng-content>\n    <button *ngIf=\"this.closable\" (click)=\"_close()\" class=\"close-button\" type=\"button\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  ",
                        encapsulation: core.ViewEncapsulation.None,
                        animations: [
                            animations.trigger('fadeOut', [
                                animations.transition('* => true', fading.fadeOut(.3))
                            ])
                        ],
                        host: {
                            '[class]': '["callout nt-callout", color || "primary", size, class].join(" ")',
                            '[class.closed]': 'closed'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtCalloutComponent.ctorParameters = function () { return []; };
        NtCalloutComponent.propDecorators = {
            title: [{ type: core.Input }],
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            class: [{ type: core.Input }],
            closable: [{ type: core.Input }],
            close: [{ type: core.Output }],
            fadeOut: [{ type: core.HostBinding, args: ['@fadeOut',] }],
            onAnimationDone: [{ type: core.HostListener, args: ['@fadeOut.done', ['$event'],] }]
        };
        return NtCalloutComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */
    var NtCalloutModule = /** @class */ (function () {
        function NtCalloutModule() {
        }
        NtCalloutModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        exports: [NtCalloutComponent],
                        declarations: [NtCalloutComponent],
                    },] },
        ];
        return NtCalloutModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
     */

    exports.NtCalloutModule = NtCalloutModule;
    exports.NtCalloutComponent = NtCalloutComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=callout.umd.js.map
