import { transition, trigger } from '@angular/animations';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Component, EventEmitter, Input, Output, ViewEncapsulation, HostBinding, HostListener, NgModule } from '@angular/core';
import { fadeOut } from '@ng-tangram/animate/fading';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
class NtCalloutComponent {
    constructor() {
        this.title = '';
        this.color = 'primary';
        this.size = 'medium';
        this.class = '';
        this._closed = false;
        this.close = new EventEmitter();
        this.fadeOut = false;
    }
    /**
     * @return {?}
     */
    get closed() { return this._closed; }
    /**
     * @param {?} value
     * @return {?}
     */
    set closable(value) { this._closable = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get closable() { return this._closable; }
    /**
     * @param {?} event
     * @return {?}
     */
    onAnimationDone(event) {
        if (event.toState) {
            this._closed = true;
        }
    }
    /**
     * @return {?}
     */
    _close() {
        if (!this.fadeOut) {
            this.fadeOut = true;
            this.close.emit();
        }
    }
}
NtCalloutComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-callout',
                template: `
    <h3 *ngIf="title">{{title}}</h3>
    <ng-content></ng-content>
    <button *ngIf="this.closable" (click)="_close()" class="close-button" type="button">
      <span aria-hidden="true">&times;</span>
    </button>
  `,
                encapsulation: ViewEncapsulation.None,
                animations: [
                    trigger('fadeOut', [
                        transition('* => true', fadeOut(.3))
                    ])
                ],
                host: {
                    '[class]': '["callout nt-callout", color || "primary", size, class].join(" ")',
                    '[class.closed]': 'closed'
                }
            },] },
];
/** @nocollapse */
NtCalloutComponent.ctorParameters = () => [];
NtCalloutComponent.propDecorators = {
    title: [{ type: Input }],
    color: [{ type: Input }],
    size: [{ type: Input }],
    class: [{ type: Input }],
    closable: [{ type: Input }],
    close: [{ type: Output }],
    fadeOut: [{ type: HostBinding, args: ['@fadeOut',] }],
    onAnimationDone: [{ type: HostListener, args: ['@fadeOut.done', ['$event'],] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */
class NtCalloutModule {
}
NtCalloutModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtCalloutComponent],
                declarations: [NtCalloutComponent],
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,uselessCode} checked by tsc
 */

export { NtCalloutModule, NtCalloutComponent };
//# sourceMappingURL=callout.js.map
